var _defaults = require('lodash.defaults');
var Readable = require('stream').Readable;
var inherits = require('util').inherits;

function BaseSampler(db, collectionName, opts) {
  this.db = db;
  this.collectionName = collectionName;

  opts = _defaults(opts || {}, {
    query: {},
    size: 5,
    fields: null,
    sort: {
      _id: -1
    }
  });

  this.query = opts.query;
  this.size = opts.size;
  this.fields = opts.fields;
  this.sort = opts.sort;

  Readable.call(this, {
    objectMode: true
  });
}
inherits(BaseSampler, Readable);

Object.defineProperty(BaseSampler.prototype, 'collection', {
  get: function() {
    return this.db.collection(this.collectionName);
  }
});

module.exports = BaseSampler;
